﻿<?xml version="1.0" encoding="utf-8"?>
<xs:schema id="bo"
    targetNamespace="http://www.netkoders.com/Schemas/Generation/Business/ViewModel"
    elementFormDefault="qualified"
    xmlns="http://www.netkoders.com/Schemas/Generation/Business/ViewModel"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:maximus="http://www.netkoders.com/Schemas/Generation/Maximus">
 
  <xs:include schemaLocation="ViewModel.Globals.xsd"/>
  <xs:include schemaLocation="ViewModel.Features.xsd"/>
  <xs:include schemaLocation="ViewModel.Property.xsd"/>
  <xs:include schemaLocation="ViewModel.Collection.xsd"/>
  <xs:include schemaLocation="ViewModel.Calculation.xsd"/>
  <xs:include schemaLocation="ViewModel.Command.xsd"/>
  <xs:include schemaLocation="ViewModel.Event.xsd"/>
  <xs:include schemaLocation="ViewModel.Update.xsd"/>
  <xs:include schemaLocation="ViewModel.Encapsulation.xsd"/>
  <xs:include schemaLocation="ViewModel.Copy.xsd"/>

  <xs:simpleType name="viewModelName">
    <xs:restriction base="xs:string">
      <xs:pattern value=".*ViewModel"/>
    </xs:restriction>
  </xs:simpleType>

  <xs:complexType name="elementViewModel">
    <xs:attribute name="Name" type="viewModelName" use="optional"/>
    <xs:attribute name="Namespace" type="xs:string" use="optional"/>
    <xs:attribute name="Inherit" type="xs:string" use="optional"/>
    <xs:attribute name="Master" type="xs:string" use="optional"/>
  </xs:complexType>
  
  <xs:element name="ViewModel">
    <xs:complexType>
      <xs:complexContent>
        <xs:extension base="elementViewModel">
          <xs:sequence minOccurs="0" maxOccurs="1">

            <!-- Element Features -->
            <xs:element name="Features" minOccurs="0" maxOccurs="1">
              <xs:complexType>
                <xs:sequence>
                  <xs:element name="Editon" type="elementFeatureEdition" minOccurs="0" maxOccurs="1">
                  </xs:element>
                  <xs:element name="Option" type="elementFeatureOptions" minOccurs="0" maxOccurs="1">
                  </xs:element>
                </xs:sequence>
              </xs:complexType>
            </xs:element>
            <!-- FIN : Element Features -->

            <xs:element name="Contract" minOccurs="1" maxOccurs="1">
              <xs:complexType>
                <xs:sequence minOccurs="1" maxOccurs="unbounded">

                  <xs:element name="Property" type="elementProperty" minOccurs="0" maxOccurs="unbounded"/>

                  <xs:element name="Collection" type="elementCollection" minOccurs="0" maxOccurs="unbounded"/>

                  <xs:element name="Calculation" type="elementCalculation" minOccurs="0" maxOccurs="unbounded"/>

                  <xs:element name="Command" type="elementCommand" minOccurs="0" maxOccurs="unbounded"/>

                  <xs:element name="Event" type="elementEvent" minOccurs="0" maxOccurs="unbounded"/>

                  <xs:element name="Update" type="elementUpdate" minOccurs="0" maxOccurs="unbounded"/>

                  <xs:element name="Encapsulation" type="elementEncapsulation" minOccurs="0" maxOccurs="unbounded"/>

                  <xs:element name="Copy" type="elementCopy" minOccurs="0" maxOccurs="unbounded"/>

                </xs:sequence>
              </xs:complexType>
            </xs:element>
          </xs:sequence>
        </xs:extension>
      </xs:complexContent>
    </xs:complexType>
  </xs:element>
</xs:schema>

